import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

public class Main {
	public static void main(String[] args) {
		try {
			SAXParserFactory factory = SAXParserFactory.newInstance();
			SAXParser saxParser = factory.newSAXParser();

			File file = new File(args[1]);

			if (file.exists()) {
				file.delete();
			}
			file.createNewFile();

			FileWriter fw = new FileWriter(file.getAbsoluteFile());
			final BufferedWriter bw = new BufferedWriter(fw);


			DefaultHandler handler = new DefaultHandler() {

				public boolean isFirstParagraph = false;
				public boolean isDivOpen = false;
				public boolean openH1 = false;
				public boolean openH2 = false;
				public boolean openH3 = false;
				public boolean openH4 = false;
				public boolean openH5 = false;
				public boolean openH6 = false;
				
				private void closeLastH1() {
					try {
						closeLastH2();
						if(openH1) {
							if(isDivOpen)
							{
								bw.write("</div>");
								isDivOpen=false;
							}
							bw.write("</section><!-- end h1 -->\n");
							openH1 = false;
							isFirstParagraph = false;
						}
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
				private void closeLastH2() {
					try {
						closeLastH3();
						if(openH2) {
						 	if(isDivOpen)
							{
								bw.write("</div>");
								isDivOpen=false;
							}
							bw.write("</section><!-- end h2 -->\n");
							openH2 = false;
							isFirstParagraph = false;
						}
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
				
				private void closeLastH3() {
					try {
						closeLastH4();
						if(openH3) {
						 	if(isDivOpen)
							{
								bw.write("</div>");
								isDivOpen=false;
							}
							bw.write("</section><!-- end h3 -->\n");
							openH3 = false;
							isFirstParagraph = false;
						}
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
				
				private void closeLastH4() {
					try {
						closeLastH5();
						if(openH4) {
						 	if(isDivOpen)
							{
								bw.write("</div>");
								isDivOpen=false;
							}
							bw.write("</section><!-- end h4 -->\n");
							openH4 = false;
							isFirstParagraph = false;
						}
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
				
				private void closeLastH5() {
					try {
						closeLastH6();
						if(openH5) {
						 	if(isDivOpen)
							{
								bw.write("</div>");
								isDivOpen=false;
							}
							bw.write("</section><!-- end h5 -->\n");
							openH5 = false;
							isFirstParagraph = false;
						}
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
				
				
			       private void closeLastH6() {
	                    if(openH6) try {
	                    	if(isDivOpen)
							{
								bw.write("</div>");
								isDivOpen=false;
							}
	                        bw.write("</section><!-- end h6 -->\n");
	                        openH6 = false;
	                        isFirstParagraph = false;
	                    } catch (IOException e) {
	                        e.printStackTrace();
	                    }
	                }


				private void openNewH1() {
					try {
						closeLastH1();
						bw.write("<section>");
						openH1 = true;
						isFirstParagraph = true;
					} catch (IOException e) {
						e.printStackTrace();
					}
				}

				private void openNewH2() {
					try {
						closeLastH2();
						if(isDivOpen)
						{
							bw.write("</div>");
							isDivOpen=false;
						}
						bw.write("<section>");
						openH2 = true;
						isFirstParagraph = true;
					} catch (IOException e) {
						e.printStackTrace();
					}
				}

				private void openNewH3() {
					try {
						closeLastH3();
						if(isDivOpen)
						{
							bw.write("</div>");
							isDivOpen=false;
						}
						bw.write("<section>");
						openH3 = true;
						isFirstParagraph = true;
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
				
				private void openNewH4() {
					try {
						closeLastH4();
						if(isDivOpen)
						{
							bw.write("</div>");
							isDivOpen=false;
						}
						bw.write("<section>");
						openH4 = true;
						isFirstParagraph = true;
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
				
				private void openNewH5() {
					try {
						closeLastH5();
						if(isDivOpen)
						{
							bw.write("</div>");
							isDivOpen=false;
						}
						bw.write("<section>");
						openH5 = true;
						isFirstParagraph = true;
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
				
				private void openNewH6() {
					try {
						closeLastH6();
						if(isDivOpen)
						{
							bw.write("</div>");
							isDivOpen=false;
						}
						bw.write("<section>");
						openH6 = true;
						isFirstParagraph = true;
					} catch (IOException e) {
						e.printStackTrace();
					}
				}


				@Override
				public void startElement(String uri, String localName, String qName, Attributes attributes) throws SAXException {
					try {
						if(qName=="text:h") {
							if(attributes.getValue("text:outline-level").equals("1")) {
								openNewH1();
							} else if(attributes.getValue("text:outline-level").equals("2")) {
								openNewH2();
							} else if (attributes.getValue("text:outline-level").equals("3")) {
								openNewH3();
							} else if(attributes.getValue("text:outline-level").equals("4")) {
								openNewH4();
							} else if (attributes.getValue("text:outline-level").equals("5")) {
								openNewH5();
							}else if (attributes.getValue("text:outline-level").equals("6")) {
								openNewH6();
							}
						}
						
						if(qName=="text:p") {
							if(isFirstParagraph==true)
							{
								bw.write("<div>");
								isFirstParagraph=false;
								isDivOpen= true;
							}
						}
						
						bw.write("<" + qName);
						for(int i = 0; i<attributes.getLength(); i++) {
							bw.write(" "+attributes.getQName(i)+"=\""+attributes.getValue(i)+"\"");
						}
						bw.write(">");
					} catch (IOException e) {
						e.printStackTrace();
					}
				}

				@Override
				public void endElement(String uri, String localName, String qName) throws SAXException {
					try {
					
						
						if(qName=="office:text") {
							closeLastH6();
							closeLastH5();
							closeLastH4();
							closeLastH3();
							closeLastH2();
							closeLastH1();
						}
						
						bw.write("</" + qName + ">");
					} catch (IOException e) {
						e.printStackTrace();
					}
				}

				@Override
				public void characters(char ch[], int start, int length) throws SAXException {
					try {
						bw.write(new String(ch, start, length));
					} catch (IOException e) {
						e.printStackTrace();
					}
				}


				@Override
				public void endDocument() throws SAXException {
					closeLastH6();
					closeLastH5();
					closeLastH4();
					closeLastH3();
					closeLastH2();
					closeLastH1();
				}
			};

			saxParser.parse(args[0], handler);

			bw.close();

		} catch (ParserConfigurationException e) {
			e.printStackTrace();
		} catch (SAXException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}


	}
}
